*** Settings ***
Documentation     增加分享设备关联用户
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/CreateShareDeviceToUserAsync.robot
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/BindDeviceAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/RemoveDeviceRelevancyAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/GetDeviceByTokenAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/GetDeviceBindUsersCodesAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/DeleteShareDeviceToUserAsync.robot

*** Test Cases ***
Class_001_增加分享设备关联用户，分享单个用户
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #增加分享设备关联用户
    ${res1}    CreateShareDeviceToUserAsyncPost    ${token}    ${usercode_maoage}[0]    ${deviceCode}
    #校验是否增加分享设备关联用户成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    ${res2}    GetDeviceBindUsersCodesAsyncPost    ${token}    ${deviceCode}
    Log    ${res2}[content][0]
    Log    ${usercode_maoage}[0]
    Should Be Equal As Strings    ${res2}[content][0]    ${usercode_maoage}[0]
    #删除分享设备关联用户
    ${delUsercode}    Create List    ${usercode_maoage}[0]
    ${res3}    DeleteShareDeviceToUserAsyncPost    ${token}    ${delUsercode}    ${deviceCode}
    #删除分享设备关联用户验证
    ${flag1}    Result Analysis    ${res3}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_002_增加分享设备关联用户，分享多个用户
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #增加分享设备关联用户
    ${res1}    CreateShareDeviceToUserAsyncPost    ${token}    ${usercode_maoage}[0],${usercode_maoage}[1],${usercode_maoage}[2],${usercode_maoage}[3]    ${deviceCode}
    #校验是否增加分享设备关联用户成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    ${res2}    GetDeviceBindUsersCodesAsyncPost    ${token}    ${deviceCode}
    @{list}    Get From Dictionary    ${res2}    content
    FOR    ${value}    IN    @{usercode_maoage}
        log    ${value}
        List Should Contain Value    ${list}    ${value}
    END
    #删除分享设备关联用户
    ${res3}    DeleteShareDeviceToUserAsyncPost    ${token}    ${usercode_maoage}    ${deviceCode}
    #删除分享设备关联用户验证
    ${flag1}    Result Analysis    ${res3}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_001_增加分享设备关联用户，Token值正确性校验
    #增加分享设备关联用户，传入不正确的Token值
    ${res}    CreateShareDeviceToUserAsyncPost    1111111    ${usercode_maoage}[0]    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_增加分享设备关联用户，Token值非空校验
    #增加分享设备关联用户，Token传入空值
    ${res}    CreateShareDeviceToUserAsyncPost    ${EMPTY}    ${usercode_maoage}[0]    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_增加分享设备关联用户，UserCodes值正确性校验
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token
    ${usToken}    ConnectAsync.GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #增加分享设备关联用户，传入不正确的UserCodes值
    ${res}    CreateShareDeviceToUserAsyncPost    ${token}    11111    ${deviceCode}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${6005}
    Should Be True    ${flag}

Exception_004_增加分享设备关联用户，UserCodes值非空校验
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token
    ${usToken}    ConnectAsync.GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #增加分享设备关联用户，UserCodes传入空值
    ${res}    CreateShareDeviceToUserAsyncPost    ${token}    ${EMPTY}    ${deviceCode}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${9}
    Should Be True    ${flag}

Exception_005_增加分享设备关联用户，DeviceCode值正确性校验
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token
    ${usToken}    ConnectAsync.GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #增加分享设备关联用户，传入不存在的DeviceCode
    ${res}    CreateShareDeviceToUserAsyncPost    ${token}    ${usercode_maoage}[0]    111111
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2000}
    Should Be True    ${flag}

Exception_006_增加分享设备关联用户，DeviceCode值非空校验
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token
    ${usToken}    ConnectAsync.GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #增加分享设备关联用户，DeviceCode传入空值
    ${res}    CreateShareDeviceToUserAsyncPost    ${token}    ${usercode_maoage}[0]    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2005}
    Should Be True    ${flag}
