*** Settings ***
Documentation     获取设备绑定用户codes
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/BindDeviceAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/RemoveDeviceRelevancyAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/GetDeviceByTokenAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/GetDeviceBindUsersCodesAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/DeleteShareDeviceToUserAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/CreateShareDeviceToUserAsync.robot

*** Test Cases ***
Class_001_获取设备绑定用户codes
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #增加分享设备关联用户
    ${res1}    CreateShareDeviceToUserAsyncPost    ${token}    ${usercode_maoage}[0],${usercode_maoage}[1],${usercode_maoage}[2],${usercode_maoage}[3]    ${deviceCode}
    #校验是否增加分享设备关联用户成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取设备绑定用户codes
    ${res2}    GetDeviceBindUsersCodesAsyncPost    ${token}    ${deviceCode}
    Log    结果结果
    Log    ${res2}
    #校验${res2}返回codes
    ${list}    Get From Dictionary    ${res2}    content
    FOR    ${value}    IN    @{usercode_maoage}
        log    ${value}
        List Should Contain Value    ${list}    ${value}
    END
    #删除分享设备关联用户
    ${res3}    DeleteShareDeviceToUserAsyncPost    ${token}    ${usercode_maoage}    ${deviceCode}
    ${flag1}    Result Analysis    ${res3}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_001_获取设备绑定用户codes，Token值正确性校验
    #获取设备绑定用户codes，传入错误的Token值
    ${res}    GetDeviceBindUsersCodesAsyncPost    1111111    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_获取设备绑定用户codes，Token值非空校验
    #获取设备绑定用户codes，不传入Token值
    ${res}    GetDeviceBindUsersCodesAsyncPost    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_获取设备绑定用户codes，DeviceCode值正确性校验
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取设备绑定用户codes，传入错误的DeviceCode值
    ${res}    GetDeviceBindUsersCodesAsyncPost    ${token}    11111
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2000}
    Should Be True    ${flag}

Exception_004_获取设备绑定用户codes，DeviceCode值非空验
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取设备绑定用户codes，DeviceCode传入空值
    ${res}    GetDeviceBindUsersCodesAsyncPost    ${token}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2005}
    Should Be True    ${flag}
