*** Settings ***
Documentation     根据设备动态唯一码获取设备信息
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/GetDeviceByTokenAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/GetDeviceByShortCodeAsync.robot

*** Test Cases ***
Class_001_根据设备动态唯一码获取设备信息
    #超声机连接云服务，获取Token、ShortCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${token}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #根据设备动态唯一码获取设备信息
    ${response}    GetDeviceByShortCodeAsyncPost    ${token}    ${uniqueCode}
    #获取响应返回ShortCode
    ${shortCode}    Get From Dictionary    ${response}[content]    ShortCode
    #校验
    Should Be Equal As Strings    ${shortCode}    ${uniqueCode}

Exception_001_根据设备动态唯一码获取设备信息，Token值正确性校验
    #根据设备动态唯一码获取设备信息,传入错误的Token值
    ${res}    GetDeviceByShortCodeAsyncPost    1111111    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_根据设备动态唯一码获取设备信息，Token值非空校验
    #根据设备动态唯一码获取设备信息,不传入Token值
    ${res}    GetDeviceByShortCodeAsyncPost    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_根据设备动态唯一码获取设备信息，ShortCode值正确性校验
    #超声机连接云服务，获取Token、ShortCode
    ${token}    GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #根据设备动态唯一码获取设备信息,传入不存在的ShortCode值
    ${res}    GetDeviceByShortCodeAsyncPost    ${token}    111111
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2000}
    Should Be True    ${flag}

Exception_004_根据设备动态唯一码获取设备信息，ShortCode值非空校验
    #超声机连接云服务，获取Token、ShortCode
    ${token}    GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #根据设备动态唯一码获取设备信息,不传入ShortCode值
    ${res}    GetDeviceByShortCodeAsyncPost    ${token}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2013}
    Should Be True    ${flag}
