*** Settings ***
Documentation     客户端-查询个人名下所有设备列表接口
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/GetPersonDeviceListAsync.robot
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/BindDeviceAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/RemoveDeviceRelevancyAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/GetDeviceByTokenAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_查询个人名下所有设备列表接口
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${EMPTY}    ${EMPTY}    ${EMPTY}    null
    #校验用户下是否有新绑定的设备
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    ${shortCodes}    Create List
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${shortCode}    Get From Dictionary    ${value}    ShortCode
        Append To List    ${shortCodes}    ${shortCode}
    END
    log    ${shortCodes}
    List Should Contain Value    ${shortCodes}    ${uniqueCode}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_002_查询个人名下所有设备列表接口，KeyWord传入存在设备名
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${deviceName}    ${EMPTY}    ${EMPTY}    null
    #校验用户下是否有新绑定的设备
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    ${shortCodes}    Create List
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${shortCode}    Get From Dictionary    ${value}    ShortCode
        Append To List    ${shortCodes}    ${shortCode}
    END
    log    ${shortCodes}
    List Should Contain Value    ${shortCodes}    ${uniqueCode}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_003_查询个人名下所有设备列表接口，KeyWord传入存在的唯一码
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${uniqueCode}    ${EMPTY}    ${EMPTY}    null
    #校验用户下是否有新绑定的设备
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    ${shortCodes}    Create List
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${shortCode}    Get From Dictionary    ${value}    ShortCode
        Append To List    ${shortCodes}    ${shortCode}
    END
    log    ${shortCodes}
    List Should Contain Value    ${shortCodes}    ${uniqueCode}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_004_查询个人名下所有设备列表接口，KeyWord传入不存在的唯一码或设备名
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    !@#$WERTY    ${EMPTY}    ${EMPTY}    null
    #校验
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    Should Be Empty    ${list}
    [Teardown]

Class_005_查询个人名下所有设备列表接口，传入存在的DeviceType
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${EMPTY}    ${deviceType_us}[0]    ${EMPTY}    null
    #校验用户下是否有新绑定的设备
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    ${shortCodes}    Create List
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${shortCode}    Get From Dictionary    ${value}    ShortCode
        Append To List    ${shortCodes}    ${shortCode}
    END
    log    ${shortCodes}
    List Should Contain Value    ${shortCodes}    ${uniqueCode}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_006_查询个人名下所有设备列表接口，传入不存在的DeviceType
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${EMPTY}    1111qwer@#$%    ${EMPTY}    null
    #校验
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    Should Be Empty    ${list}
    [Teardown]

Class_007_查询个人名下所有设备列表接口，传入存在的DeviceModel值
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${EMPTY}    ${EMPTY}    ${deviceType_us}[1]    null
    #校验用户下是否有新绑定的设备
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    ${shortCodes}    Create List
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${shortCode}    Get From Dictionary    ${value}    ShortCode
        Append To List    ${shortCodes}    ${shortCode}
    END
    log    ${shortCodes}
    List Should Contain Value    ${shortCodes}    ${uniqueCode}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_008_查询个人名下所有设备列表接口，传入不存在的DeviceModel
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${EMPTY}    ${EMPTY}    1111qwer@#$%    null
    #校验
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    Should Be Empty    ${list}
    [Teardown]

Class_009_查询个人名下所有设备列表接口，设备在线
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${deviceName}    ${EMPTY}    ${EMPTY}    true
    #校验用户下是否有新绑定的设备
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    ${shortCodes}    Create List
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${shortCode}    Get From Dictionary    ${value}    ShortCode
        Append To List    ${shortCodes}    ${shortCode}
    END
    log    ${shortCodes}
    List Should Contain Value    ${shortCodes}    ${uniqueCode}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_010_查询个人名下所有设备列表接口，设备不在线
    [Setup]
    [Template]
    #用户登录获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${response}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #获取设备DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #查询个人名下所有设备下拉列表
    ${res1}    GetPersonDeviceListAsyncPost    ${token}    1    1000    ${deviceName}    ${EMPTY}    ${EMPTY}    false
    #校验用户下是否不包含新绑定的设备
    @{list}    Get From Dictionary    ${res1}[content]    PageData
    ${shortCodes}    Create List
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${shortCode}    Get From Dictionary    ${value}    ShortCode
        Append To List    ${shortCodes}    ${shortCode}
    END
    log    ${shortCodes}
    List Should Not Contain Value    ${shortCodes}    ${uniqueCode}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_001_查询个人名下所有设备列表接口，Token非空校验
    [Template]
    #查询个人名下所有设备下拉列表
    ${res}    GetPersonDeviceListAsyncPost    ${EMPTY}    1    1000    ${EMPTY}    ${EMPTY}    ${EMPTY}    null
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_查询个人名下所有设备列表接口，Token正确性校验
    [Template]
    #查询个人名下所有设备下拉列表
    ${res}    GetPersonDeviceListAsyncPost    111111    1    1000    ${EMPTY}    ${EMPTY}    ${EMPTY}    null
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

*** Keywords ***
