*** Settings ***
Documentation     修改设备信息
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/BindDeviceAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/RemoveDeviceRelevancyAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/GetDeviceByTokenAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/GetDeviceInfoAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/ModifyDeviceAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/AddOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/SearchOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/RemoveOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/GetShareDeviceUsersAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/DeleteShareDeviceToUserAsync.robot

*** Test Cases ***
Class_001_修改设备信息，修改Description
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备信息，修改name
    ${deviceDescription1}    Set Variable    sonotest
    ${res2}    ModifyDeviceAsyncPost    ${token}    ${deviceCode}    ${deviceName}    ${EMPTY}    ${EMPTY}    false    ${deviceDescription1}
    #校验
    ${flag}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    ${res3}    GetDeviceInfoAsyncPost    ${token}    ${deviceCode}
    ${desc}    Get From Dictionary    ${res3}[content]    Description
    Should Be Equal As Strings    ${desc}    ${deviceDescription1}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_002_修改设备信息，修改HeadPicUrl
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备信息，修改HeadPicUrl
    ${res2}    ModifyDeviceAsyncPost    ${token}    ${deviceCode}    ${deviceName}    ${image}[0]    ${EMPTY}    false    descr
    #校验
    ${flag}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    ${res3}    GetDeviceInfoAsyncPost    ${token}    ${deviceCode}
    ${headPicUrl}    Get From Dictionary    ${res3}[content]    HeadPicUrl
    #校验图片名称
    ${headImageUrls}    Split String    ${headPicUrl}    /
    Log    ${headImageUrls}
    ${headImageLen}    Get Length    ${headImageUrls}
    ${images}    Split String    ${image}[0]    /
    Log    ${images}
    ${imagesLen}    Get Length    ${images}
    Should Be Equal As Strings    ${headImageUrls}[${headImageLen-1}]    ${images}[${imagesLen-1}]
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_003_修改设备信息，修改DepartmentCode
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag1}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #新建部门
    #随机生成组织名
    ${oranName}    Random Characters
    #添加组织
    ${resOra}    AddOrganizationsAsyncPost    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${EMPTY}    ${patientType}[0]    ${languageCode}[0]
    #校验
    ${flag2}    Result Analysis    ${resOra}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag2}
    #搜索组织，返回OrganizationCode
    ${depCode}    SearchOrganizationsAsyncOrganizationCode    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    #修改设备信息，修改DepartmentCode
    ${res2}    ModifyDeviceAsyncPost    ${token}    ${deviceCode}    ${deviceName}    ${EMPTY}    ${depCode}    false    descr
    #校验
    ${flag3}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag3}
    #获取设备的DeviceCode
    ${res3}    GetDeviceInfoAsyncPost    ${token}    ${deviceCode}
    ${departmentCode}    Get From Dictionary    ${res3}[content]    DepartmentCode
    Should Be Equal As Strings    ${departmentCode}    ${depCode}
    #移除机构设备
    ${res4}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${depCode}    ${deviceCode}
    ${flag4}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag4}
    #删除组织
    ${response}    RemoveOrganizationsAsyncPost    ${token}    ${depCode}
    #删除组织校验
    ${flag5}    Result Analysis    ${response}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag5}
    [Teardown]

Class_004_修改设备信息，修改IsAutoShared
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备链接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    #${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    #Should Be True    ${flag}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备信息，修改isAutoShared
    ${res2}    ModifyDeviceAsyncPost    ${token}    ${deviceCode}    ${deviceName}    ${EMPTY}    ${EMPTY}    true    descr
    #校验
    ${flag}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    ${res3}    GetShareDeviceUsersAsyncPost    ${token}    1    10000    ${deviceCode}
    ${result}    Get From Dictionary    ${res3}    content
    @{pageData}    Get From Dictionary    ${result}    PageData
    #校验包含@{usercode_maoage}里面的用户
    ${UserCodes}    Create List
    FOR    ${value}    IN    @{pageData}
        log    ${value}
        Append To List    ${UserCodes}    ${value}[UserCode]
    END
    log    ${UserCodes}
    log    ${usercode_maoage}
    List Should Contain Sub List    ${UserCodes}    ${usercode_maoage}
    #UserCodes传值
    ${res4}    DeleteShareDeviceToUserAsyncPost    ${token}    ${UserCodes}    ${deviceCode}
    log    ${res4}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_001_修改设备信息，Token值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备链接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag1}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备信息，传入错误的Token值
    ${res2}    ModifyDeviceAsyncPost    111111    ${deviceCode}    ${deviceName}    ${EMPTY}    ${EMPTY}    false    descr
    #校验
    ${flag2}    Result Analysis Code    ${res2}    false    ${1}
    Should Be True    ${flag2}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_002_修改设备信息，Token值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备链接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag1}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备信息，Token传入空值
    ${res2}    ModifyDeviceAsyncPost    ${EMPTY}    ${deviceCode}    ${deviceName}    ${EMPTY}    ${EMPTY}    false    descr
    #校验
    ${flag2}    Result Analysis Code    ${res2}    false    ${1}
    Should Be True    ${flag2}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_003_修改设备信息，DeviceCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备链接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag1}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备信息，传入不存在的DeviceCode值
    ${res2}    ModifyDeviceAsyncPost    ${token}    11111    ${deviceName}    ${EMPTY}    ${EMPTY}    false    descr
    #校验
    ${flag2}    Result Analysis Code    ${res2}    false    ${2015}
    Should Be True    ${flag2}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_004_修改设备信息，DeviceCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备链接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${deviceName}    Set Variable    sono
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag1}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备信息，DeviceCode传入空值
    ${deviceName1}    Set Variable    sonotest
    ${res2}    ModifyDeviceAsyncPost    ${token}    ${EMPTY}    ${deviceName}    ${EMPTY}    ${EMPTY}    false    descr
    #校验
    ${flag2}    Result Analysis Code    ${res2}    false    ${9}
    Should Be True    ${flag2}
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}
