*** Settings ***
Documentation     修改设备AI应用启用状态
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/BindDeviceAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/RemoveDeviceRelevancyAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/GetDeviceByTokenAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/GetDeviceInfoAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/ModifyDeviceDiagnosisModuleStateAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/FindDeviceDiagnosisModulesAsync.robot

*** Test Cases ***
Class_001_修改设备AI启用状态，开启乳腺智能辅助诊断
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    sonotest    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备AI应用启用状态
    ${res2}    ModifyDeviceDiagnosisModuleStateAsyncPost    ${token}    ${deviceCode}    ${diagnosisModule}[1]    true
    #校验开启乳腺智能辅助诊断成功
    ${flag1}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    ${res3}    FindDeviceDiagnosisModulesAsyncPost    ${token}    ${deviceCode}
    log    ${res3}
    #遍历找到${diagnosisModule}[1]对应的值，校验是否等于true
    ${findValue}    Set variable    {}
    @{list}    Get From Dictionary    ${res3}    content
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${findValue}    Run Keyword If    '${value}[DiagnosisModule]' == '${diagnosisModule}[1]'    Set variable    ${value}
        Exit For Loop If    '${value}[DiagnosisModule]' == '${diagnosisModule}[1]'
    END
    log    ${findValue}
    Should Be True    ${findValue}[Enabled]
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Class_002_修改设备AI启用状态，关闭乳腺智能辅助诊断
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    sonotest    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备AI应用启用状态
    ${res2}    ModifyDeviceDiagnosisModuleStateAsyncPost    ${token}    ${deviceCode}    ${diagnosisModule}[1]    false
    #校验关闭乳腺智能辅助诊断成功
    ${flag1}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    ${res3}    FindDeviceDiagnosisModulesAsyncPost    ${token}    ${deviceCode}
    log    ${res3}
    #遍历找到${diagnosisModule}[1]对应的值，校验是否等于false
    ${findValue}    Set variable    {}
    @{list}    Get From Dictionary    ${res3}    content
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${findValue}    Run Keyword If    '${value}[DiagnosisModule]' == '${diagnosisModule}[1]'    Set variable    ${value}
        Exit For Loop If    '${value}[DiagnosisModule]' == '${diagnosisModule}[1]'
    END
    log    ${findValue}
    Should Not Be True    ${findValue}[Enabled]
    [Teardown]    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}

Exception_001_修改设备AI启用状态，Token值正确性校验
    #修改设备AI应用启用状态，传入错误的Token值
    ${res}    ModifyDeviceDiagnosisModuleStateAsyncPost    1111111    ${EMPTY}    ${diagnosisModule}[1]    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_修改设备AI启用状态，Token值非空校验
    #修改设备AI应用启用状态，Token传入空值
    ${res}    ModifyDeviceDiagnosisModuleStateAsyncPost    ${EMPTY}    ${EMPTY}    ${diagnosisModule}[1]    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_修改设备AI启用状态，DeviceCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #修改设备AI应用启用状态，传入不存在的DeviceCode
    ${res}    ModifyDeviceDiagnosisModuleStateAsyncPost    ${token}    111111    ${diagnosisModule}[1]    false
    #校验
    ${flag}    Result Analysis    ${res}    false    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}

Exception_004_修改设备AI启用状态，DeviceCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #修改设备AI应用启用状态，DeviceCode传入空值
    ${res}    ModifyDeviceDiagnosisModuleStateAsyncPost    ${token}    ${EMPTY}    ${diagnosisModule}[1]    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2005}
    Should Be True    ${flag}

Exception_005_修改设备AI启用状态，DiagnosisModule值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token
    ${usToken}    GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备AI应用启用状态，传入不存在的DiagnosisModule
    ${res}    ModifyDeviceDiagnosisModuleStateAsyncPost    ${token}    ${deviceCode}    1111111    false
    #校验
    ${flag}    Result Analysis    ${res}    false    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}

Exception_006_修改设备AI启用状态，DiagnosisModule值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token
    ${usToken}    GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #修改设备AI应用启用状态，DiagnosisModule传入空值
    ${res}    ModifyDeviceDiagnosisModuleStateAsyncPost    ${token}    ${deviceCode}    ${EMPTY}    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2006}
    Should Be True    ${flag}
