*** Settings ***
Documentation     机构设备移除
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/BindDeviceAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/RemoveDeviceRelevancyAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/GetDeviceByTokenAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/GetDeviceInfoAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/AddOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/SearchOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/RemoveOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/DeviceInformationApi/FindDevicesByOrganizationCodeAsync.robot

*** Test Cases ***
Class_001_机构设备移除，移除机构设备
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #绑定设备至jo下级测试医院
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    sonotest    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    log    ${deviceCode}
    #校验设备属于jo下级测试医院
    ${res2}    GetDeviceInfoAsyncPost    ${token}    ${deviceCode}
    ${organizationCode1}    Get From Dictionary    ${res2}[content]    OrganizationCode
    Should Be Equal As Strings    ${organizationCode1}    ${organizationCode}
    #机构设备移除
    ${res3}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}
    #校验
    ${flag1}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #校验机构下不存在移除的设备
    ${res4}    FindDevicesByOrganizationCodeAsyncPost    ${token}    ${organizationInfo_mao}[0]
    log    ${res4}
    ${containsFalg}    Set variable    False
    @{list}    Get From Dictionary    ${res4}    content
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${containsFalg}    Run Keyword If    '${deviceCode}' == '${value}[DeviceCode]'    Set variable    true
        Exit For Loop If    '${deviceCode}' == '${value}[DeviceCode]'
    END
    log    ${containsFalg}
    Should Not Be True    ${containsFalg}

Class_002_机构设备移除，移除部门设备
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #新建部门
    #随机生成组织名
    ${oranName}    Random Characters
    #添加组织
    ${resOra}    AddOrganizationsAsyncPost    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${EMPTY}    ${patientType}[0]    ${languageCode}[0]
    #校验
    ${flag2}    Result Analysis    ${resOra}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag2}
    #搜索组织，返回OrganizationCode
    ${depCode}    SearchOrganizationsAsyncOrganizationCode    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    #绑定设备至jo下级测试医院的部门
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    sonotest    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${depCode}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #校验设备属于jo下级测试医院
    ${res2}    GetDeviceInfoAsyncPost    ${token}    ${deviceCode}
    ${organizationCode1}    Get From Dictionary    ${res2}[content]    OrganizationCode
    Should Be Equal As Strings    ${organizationCode1}    ${organizationCode}
    #机构设备移除
    ${res3}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${depCode}    ${deviceCode}
    #校验
    ${flag1}    Result Analysis    ${res3}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #校验机构下不存在移除的设备
    ${res4}    FindDevicesByOrganizationCodeAsyncPost    ${token}    ${organizationInfo_mao}[0]
    log    ${res4}
    ${containsFalg}    Set variable    False
    @{list}    Get From Dictionary    ${res4}    content
    FOR    ${value}    IN    @{list}
        log    ${value}
        ${containsFalg}    Run Keyword If    '${deviceCode}' == '${value}[DeviceCode]'    Set variable    true
        Exit For Loop If    '${deviceCode}' == '${value}[DeviceCode]'
    END
    log    ${containsFalg}
    Should Not Be True    ${containsFalg}
    [Teardown]    RemoveOrganizationsAsyncPost    ${token}    ${depCode}

Exception_001_机构设备移除，Token值非空校验
    #机构设备移除，Token传入空值
    ${res}    RemoveDeviceRelevancyAsyncPost    ${EMPTY}    ${organizationCode}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_机构设备移除，Token值正确性校验
    #机构设备移除，传入错误的Token值
    ${res}    RemoveDeviceRelevancyAsyncPost    11111    ${organizationCode}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_机构设备移除，OrganizationCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${usToken}    GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #机构设备移除，OrganizationCode传入空值
    ${res}    RemoveDeviceRelevancyAsyncPost    ${token}    ${EMPTY}    ${EMPTY}    ${deviceCode}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2014}
    Should Be True    ${flag}

Exception_004_机构设备移除，OrganizationCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${usToken}    GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #机构设备移除，传入不存在的OrganizationCode值
    ${res}    RemoveDeviceRelevancyAsyncPost    ${token}    1111111    ${EMPTY}    ${deviceCode}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2015}
    Should Be True    ${flag}

Exception_005_机构设备移除，DeviceCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #机构设备移除，DeviceCode传入空值
    ${res}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2014}
    Should Be True    ${flag}

Exception_006_机构设备移除，DeviceCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${usToken}    GetConnectAsyncToken    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #机构设备移除，传入不存在的DeviceCode值
    ${res}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    111111
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2015}
    Should Be True    ${flag}

Exception_007_机构设备移除，DepartmentCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #新建部门
    #随机生成组织名
    ${oranName}    Random Characters
    #添加组织
    ${resOra}    AddOrganizationsAsyncPost    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${EMPTY}    ${patientType}[0]    ${languageCode}[0]
    #校验
    ${flag1}    Result Analysis    ${resOra}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #搜索组织，返回OrganizationCode
    ${depCode}    SearchOrganizationsAsyncOrganizationCode    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    #绑定设备至jo下级测试医院的部门
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    sonotest    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${depCode}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag2}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag2}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #机构设备移除，不传入DepartmentCode值
    ${res2}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${EMPTY}    ${deviceCode}
    #校验
    ${flag3}    Result Analysis Code    ${res2}    false    ${2015}
    Should Be True    ${flag3}
    ${res3}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${depCode}    ${deviceCode}
    ${flag4}    Result Analysis    ${res3}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag4}
    [Teardown]    RemoveOrganizationsAsyncPost    ${token}    ${depCode}

Exception_008_机构设备移除，DepartmentCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #超声设备连接云服务，获取超声设备Token、UniqueCode
    ${res}    ConnectAsyncPost    BFEBFBFF000906EA-627629CA-B70D-418E-8238-5FA9E077D0F6    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    ${usToken}    Get From Dictionary    ${res}[content]    Token
    ${uniqueCode}    Get From Dictionary    ${res}[content]    UniqueCode
    #新建部门
    #随机生成组织名
    ${oranName}    Random Characters
    #添加组织
    ${resOra}    AddOrganizationsAsyncPost    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${EMPTY}    ${patientType}[0]    ${languageCode}[0]
    #校验
    ${flag1}    Result Analysis    ${resOra}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #搜索组织，返回OrganizationCode
    ${depCode}    SearchOrganizationsAsyncOrganizationCode    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    #绑定设备至jo下级测试医院的部门
    ${res1}    BindDeviceAsyncPost    ${token}    ${EMPTY}    sonotest    ${EMPTY}    ${EMPTY}    ${organizationCode}    ${depCode}    ${uniqueCode}    false
    #校验是否绑定成功
    ${flag2}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag2}
    #获取设备的DeviceCode
    ${deviceCode}    GetDeviceByTokenAsyncPost_DeviceCode    ${usToken}
    #机构设备移除，传入不正确的DepartmentCode值
    ${res2}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    1111111    ${deviceCode}
    #校验
    ${flag3}    Result Analysis Code    ${res2}    false    ${2015}
    Should Be True    ${flag3}
    ${res3}    RemoveDeviceRelevancyAsyncPost    ${token}    ${organizationCode}    ${depCode}    ${deviceCode}
    ${flag4}    Result Analysis    ${res3}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag4}
    [Teardown]    RemoveOrganizationsAsyncPost    ${token}    ${depCode}
