*** Settings ***
Documentation     创建检查记录
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Library           CustomLibrary
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/CreateRecordInfoAsync.robot

*** Test Cases ***
Class_001_创建检查记录，常规检查
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #${res_CreatePatient}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    #分页查询病人列表
    #${startTime}=    Get Current Date    UTC    - 1 hours
    #${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    #${endTime}=    Get Current Date    UTC
    #${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    #${res_findPatient}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    2
    #获取病人code
    #${pageData}    Get From Dictionary    ${res_findPatient}[content]    PageData
    #${first_dit}    Set Variable    ${pageData[0]}
    #${patientCode}    Get From Dictionary    ${first_dit}    PatientCode
    #创建检查记录
    ${patientInfoExtList}    Create Record    Routine    60    165    1.66    22.04
    ${res_createRecord}    CreateRecordInfoAsyncPost    ${token}    ${patientCode}    ${deviceCode_jopc}    ${patientInfoExtList}
    #校验
    ${flag}    Result Analysis    ${res_createRecord}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}

Exception_001_创建检查记录，Token值非空校验
    #Token值传入空值
    ${res}    CreateRecordInfoAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_创建检查记录，Token值正确性校验
    #传入错误的Token值
    ${res}    CreateRecordInfoAsyncPost    123aaa!@#$    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_创建检查记录，PatientCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #PatientCode值传入空值
    ${res}    CreateRecordInfoAsyncPost    ${token}    ${EMPTY}    ${deviceCode_jopc}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4046}
    Should Be True    ${flag}

Exception_004_创建检查记录，PatientCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #传入错误的PatientCode值
    ${res}    CreateRecordInfoAsyncPost    ${token}    123456789    ${deviceCode_jopc}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4014}
    Should Be True    ${flag}

Exception_005_创建检查记录，DeviceCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #DeviceCode值传入空值
    ${res}    CreateRecordInfoAsyncPost    ${token}    A6E5C70F51834553A14571F684B3A169    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2005}
    Should Be True    ${flag}

Exception_006_创建检查记录，DeviceCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #传入错误的DeviceCode值
    ${res}    CreateRecordInfoAsyncPost    ${token}    ${patientCode}    123456789    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${2000}
    Should Be True    ${flag}
