*** Settings ***
Documentation     分页查找检查列表
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Library           CustomLibrary
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/CreateRecordInfoAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/GetRecordInfoPagesAsync.robot

*** Test Cases ***
Class_001_分页查找检查列表
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #创建检查记录
    ${patientInfoExtList}    Create Record    Routine    60    165    1.66    22.04
    ${res_createRecord}    CreateRecordInfoAsyncPost    ${token}    ${patientCode}    ${deviceCode_jopc}    ${patientInfoExtList}
    #分页查找检查列表
    ${res_getRecord}    GetRecordInfoPagesAsyncPost    ${token}    1    60    ${patientCode}    0    0
    #校验，TotalCount等于0
    ${totalCount}    Get From Dictionary    ${res_getRecord}[content]    TotalCount
    Should Be Equal As Integers    ${totalCount}    1

Class_002_分页查找检查列表，病人记录下无检查记录
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #分页查找检查列表
    ${res_getRecord}    GetRecordInfoPagesAsyncPost    ${token}    1    60    ${patientCode}    0    0
    #校验，TotalCount等于0
    ${totalCount}    Get From Dictionary    ${res_getRecord}[content]    TotalCount
    Should Be Equal As Integers    ${totalCount}    0

Exception_001_分页查找检查列表，Token值非空校验
    #Token值传入空值
    ${res}    GetRecordInfoPagesAsyncPost    ${EMPTY}    1    60    ${EMPTY}    0    0
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_分页查找检查列表，Token值正确性校验
    #传入错误的Token值
    ${res}    GetRecordInfoPagesAsyncPost    1111QQQ!@#$#    1    60    ${EMPTY}    0    0
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_分页查找检查列表，PatientCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #PatientCode值传入空值
    ${res}    GetRecordInfoPagesAsyncPost    ${token}    1    60    ${EMPTY}    0    0
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4046}
    Should Be True    ${flag}

Exception_004_分页查找检查列表，PatientCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #传入不存在的PatientCode值
    ${res}    GetRecordInfoPagesAsyncPost    ${token}    1    60    123aaa!@#$    0    0
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4014}
    Should Be True    ${flag}
