*** Settings ***
Documentation     查询检查记录详情
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Library           CustomLibrary
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/CreateRecordInfoAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/GetRecordInfoPagesAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/QueryRecordInfoAsync.robot

*** Test Cases ***
Class_001_查询检查记录详情
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #创建检查记录
    ${patientInfoExtList}    Create Record    Routine    60    165    1.66    22.04
    ${res_createRecord}    CreateRecordInfoAsyncPost    ${token}    ${patientCode}    ${deviceCode_jopc}    ${patientInfoExtList}
    #分页查找检查列表
    ${res_getRecord}    GetRecordInfoPagesAsyncPost    ${token}    1    60    ${patientCode}    0    0
    #获取RecordCode
    ${pageData_record}    Get From Dictionary    ${res_getRecord}[content]    PageData
    ${firstRecord_dit}    Set Variable    ${pageData_record[0]}
    ${recordCode}    Get From Dictionary    ${firstRecord_dit}    RecordCode
    #查询检查记录详情
    ${res_queryRecordInfo}    QueryRecordInfoAsyncPost    ${token}    ${recordCode}
    #校验
    Should Not Be Empty    ${res_queryRecordInfo}[content]

Exception_001_查询检查记录详情，Token值非空校验
    #Token值传入空值
    ${res}    QueryRecordInfoAsyncPost    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_查询检查记录详情，Token值正确性校验
    #传入错误的Token值
    ${res}    QueryRecordInfoAsyncPost    123qas!@#    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_查询检查记录详情，RecordCode值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #RecordCode传入空值
    ${res}    QueryRecordInfoAsyncPost    ${token}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4026}
    Should Be True    ${flag}

Exception_004_查询检查记录详情，RecordCode值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #传入错误的RecordCode值
    ${res}    QueryRecordInfoAsyncPost    ${token}    123aaa!@#
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4016}
    Should Be True    ${flag}
