*** Settings ***
Documentation     关联检查
Library           CustomLibrary
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/RelevanceRecordAsync.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/CreateRecordInfoAsync.robot
Resource          ../../../AllApi/ClientAPI/InspectionRecordApi/GetRecordInfoPagesAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/DeviceAPI/DeviceIRemedicalService/CreateExamInfoAsync.robot
Resource          ../../../AllApi/DeviceAPI/DeviceIRemedicalService/UploadExamDataAsync.robot

*** Test Cases ***
Class_001_关联检查
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #超声设备连接云服务(JMHLHL)，获取超声设备Token
    ${usToken}    ConnectAsync.GetConnectAsyncToken    BFEBFBFF000906EA-S3YHNX0KC24771X    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #超声机传一条未登记的病人检查
    ${patientDatas}    patient_body    ${enName}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    20230602111    ${EMPTY}
    ${patientScanInfos}    create_record    Routine    55    165    1.66    22.04
    ${res_CreateExamCode}    CreateExamInfoAsyncPost_ExamCode    ${usToken}    Person    ${EMPTY}    ${patientDatas}    ${patientScanInfos}
    ${res_uploadExamData}    UploadExamDataAsyncPost    ${usToken}    ${res_CreateExamCode}    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/4A18DA330CA24CA0935E09057498EC54.jpg    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/C5EE8AA2DD26437DBFF48B337712220E.vid    82604    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/64D98B9B8D314E60A58DD448E0F658F5.jpg    ABD    Abd General    0
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #创建检查记录
    ${patientInfoExtList}    Create Record    Routine    60    165    1.66    22.04
    ${res_createRecord}    CreateRecordInfoAsyncPost    ${token}    ${patientCode}    ${deviceCode_jopc}    ${patientInfoExtList}
    #分页查找检查列表
    ${res_getRecord}    GetRecordInfoPagesAsyncPost    ${token}    1    60    ${patientCode}    0    0
    #获取RecordCode
    ${pageData_record}    Get From Dictionary    ${res_getRecord}[content]    PageData
    ${firstRecord_dit}    Set Variable    ${pageData_record[0]}
    ${recordCode}    Get From Dictionary    ${firstRecord_dit}    RecordCode
    #
    #关联检查
    ${res_relevanceRecord}    RelevanceRecordAsyncPost    ${token}    ${res_CreateExamCode}    ${recordCode}
    #校验
    ${flag}    Result Analysis    ${res_relevanceRecord}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}

Exception_001_关联检查，Token非空校验
    #Token值传入空值
    ${res}    RelevanceRecordAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_关联检查，Token正确性校验
    #传入错误的Token值
    ${res}    RelevanceRecordAsyncPost    123aaa!@#    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_关联检查，ExamCode非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #创建检查记录
    ${patientInfoExtList}    Create Record    Routine    60    165    1.66    22.04
    ${res_createRecord}    CreateRecordInfoAsyncPost    ${token}    ${patientCode}    ${deviceCode_jopc}    ${patientInfoExtList}
    #分页查找检查列表
    ${res_getRecord}    GetRecordInfoPagesAsyncPost    ${token}    1    60    ${patientCode}    0    0
    #获取RecordCode
    ${pageData_record}    Get From Dictionary    ${res_getRecord}[content]    PageData
    ${firstRecord_dit}    Set Variable    ${pageData_record[0]}
    ${recordCode}    Get From Dictionary    ${firstRecord_dit}    RecordCode
    #ExamCode值传入空值
    ${res}    RelevanceRecordAsyncPost    ${token}    ${EMPTY}    ${recordCode}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${9}
    Should Be True    ${flag}

Exception_004_关联检查，ExamCode正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #创建检查记录
    ${patientInfoExtList}    Create Record    Routine    60    165    1.66    22.04
    ${res_createRecord}    CreateRecordInfoAsyncPost    ${token}    ${patientCode}    ${deviceCode_jopc}    ${patientInfoExtList}
    #分页查找检查列表
    ${res_getRecord}    GetRecordInfoPagesAsyncPost    ${token}    1    60    ${patientCode}    0    0
    #获取RecordCode
    ${pageData_record}    Get From Dictionary    ${res_getRecord}[content]    PageData
    ${firstRecord_dit}    Set Variable    ${pageData_record[0]}
    ${recordCode}    Get From Dictionary    ${firstRecord_dit}    RecordCode
    #ExamCode值传入空值
    ${res}    RelevanceRecordAsyncPost    ${token}    123456    ${recordCode}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4015}
    Should Be True    ${flag}

Exception_005_关联检查，RservationCode非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #RservationCode值传入空值
    ${res}    RelevanceRecordAsyncPost    ${token}    BC7FB959DB064321AF7ABE0EC8F10D96    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${9}
    Should Be True    ${flag}

Exception_006_关联检查，RservationCode正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #传入错误的RservationCode值
    ${res}    RelevanceRecordAsyncPost    ${token}    BC7FB959DB064321AF7ABE0EC8F10D96    123456
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4019}
    Should Be True    ${flag}
