*** Settings ***
Documentation     客户端-获取所有职称
Suite Setup
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/AddRanksAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/GetAllRanksAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/RemoveRanksAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_获取所有职称信息，仅Token传值
    [Template]
    #随机生成职称名
    ${raName}    Random Characters
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #添加职称信息
    ${res}    AddRanksAsyncPost    ${token}    ${raName}    ${organizationInfo_mao}[0]    ${EMPTY}
    Log    ${res}
    #添加职称成功校验
    ${flag1}    Result Analysis    ${res}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #获取所有职称信息
    ${res1}    GetAllRanksAsyncPost    ${token}    ${EMPTY}    ${EMPTY}
    Log    ${res1}
    #获取所有职称信息非空校验
    ${content}    Get From Dictionary    ${res1}    content
    Should Not Be Empty    ${content}
    #获取新添加职称信息记录的RankCode
    ${rankCodes}    GetAllRanksAsyncPost_RankCodeLi    ${token}    ${EMPTY}    ${organizationInfo_mao}[0]
    #删除职称
    ${response}    RemoveRanksAsyncPost_RankCodes    ${token}    ${rankCodes}
    #删除组织校验
    ${flag2}    Result Analysis    ${response}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag2}

Class_002_获取所有职称信息，传入RankCodeOrganizationCode
    [Template]
    #随机生成职称名
    ${raName1}    Random Characters
    ${raName2}    Random Characters
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #添加职称信息1
    ${res1}    AddRanksAsyncPost    ${token}    ${raName1}    ${organizationInfo_mao}[0]    ${EMPTY}
    Log    ${res1}
    #添加职称1成功校验
    ${flag1}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}
    #添加职称信息2
    ${res2}    AddRanksAsyncPost    ${token}    ${raName2}    ${organizationInfo_mao}[0]    ${EMPTY}
    Log    ${res2}
    #添加职称2成功校验
    ${flag2}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag2}
    #获取所有职称信息非空校验
    ${rankCodes}    GetAllRanksAsyncPost_RankCodeLi    ${token}    ${EMPTY}    ${organizationInfo_mao}[0]
    Should Not Be Empty    ${rankCodes}
    #删除新添加的职称信息
    ${response}    RemoveRanksAsyncPost_RankCodes    ${token}    ${rankCodes}
    #删除组织校验
    ${flag2}    Result Analysis    ${response}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag2}

Exception_001_获取所有职称信息，Token非空校验
    [Template]
    #获取所有职称信息
    ${res}    GetAllRanksAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}
    Log    ${res}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_002_获取所有职称信息，Token正确性校验
    [Template]
    #获取所有职称信息
    ${res}    GetAllRanksAsyncPost    11111    ${EMPTY}    ${EMPTY}
    Log    ${res}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

*** Keywords ***
