*** Settings ***
Documentation     客户端-获取语言配置列表
Suite Setup
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/GetLangugeDataListAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_获取语言配置列表，中文
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取语言配置列表
    ${res}    GetLangugeDataListAsyncPost    ${token}    ${languageCode}[0]    0.1    ${EMPTY}
    Log    ${res}
    ${content}    Get From Dictionary    ${res}    content
    Should Not Be Empty    ${content}

Class_002_获取语言配置列表，英文
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取语言配置列表
    ${res}    GetLangugeDataListAsyncPost    ${token}    ${languageCode}[1]    9.9    ${EMPTY}
    Log    ${res}
    ${content}    Get From Dictionary    ${res}    content
    Should Not Be Empty    ${content}

Exception_001_获取语言配置列表，Token非空校验
    [Template]
    #获取语言配置列表
    ${res}    GetLangugeDataListAsyncPost    ${EMPTY}    ${languageCode}[1]    ${EMPTY}    ${EMPTY}
    Log    ${res}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_002_获取语言配置列表，Token正确性校验
    [Template]
    #获取语言配置列表
    ${res}    GetLangugeDataListAsyncPost    11111    ${languageCode}[1]    ${EMPTY}    ${EMPTY}
    Log    ${res}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

*** Keywords ***
