*** Settings ***
Documentation     客户端-根据编号获取机构信息
Suite Setup
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/GetOrganizationByCodeAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_根据编号获取机构信息
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #根据编号获取机构信息
    ${res}    GetOrganizationByCodeAsyncPost    ${token}    ${organizationInfo_mao}[0]
    Log    ${res}
    #校验
    ${content}    Get From Dictionary    ${res}    content
    ${organizationCode}    Get From Dictionary    ${content}    OrganizationCode
    Should Be Equal As Strings    ${organizationCode}    ${organizationInfo_mao}[0]

Class_002_根据编号获取机构信息，填写不存在组织编码
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #根据编号获取机构信息
    ${res}    GetOrganizationByCodeAsyncPost    ${token}    111111
    Log    ${res}
    #校验
    ${content}    Get From Dictionary    ${res}    content
    Should Be Empty    ${content}

Exception_001_根据编号获取机构信息，OrganizationCode非空校验
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #根据编号获取机构信息
    ${res}    GetOrganizationByCodeAsyncPost    ${token}    ${EMPTY}
    Log    ${res}
    #校验
    ${content}    Get From Dictionary    ${res}    content
    Should Be Empty    ${content}

Exception_002_根据编号获取机构信息， Token非空校验
    [Template]
    #根据编号获取机构信息
    ${res}    GetOrganizationByCodeAsyncPost    ${EMPTY}    ${organizationInfo_mao}[0]
    Log    ${res}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_003_根据编号获取机构信息， Token正确性检验
    [Template]
    #根据编号获取机构信息
    ${res}    GetOrganizationByCodeAsyncPost    11111    ${organizationInfo_mao}[0]
    Log    ${res}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

*** Keywords ***
