*** Settings ***
Documentation     客户端-查询机构详细信息 根据 机构编码
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/GetPersonOrganizationAsync.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonSignUpAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_查询机构详细信息
    [Setup]
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #查询机构详细信息
    ${res}    GetPersonOrganizationAsyncPost    ${token}
    #校验
    ${content}    Get From Dictionary    ${res}    content
    ${organizationCode}    Get From Dictionary    ${content}    OrganizationCode
    Should Be Equal As Strings    ${organizationCode}    ${organizationInfo_mao}[0]

Exception_001_查询机构详细信息，用户未完善个人信息
    [Setup]
    [Template]
    #注册一个新账号
    ${username}    Random Characters
    ${res}    CommonSignUpAsyncPost    ${username}    ${EMPTY}    ${pass1}
    Log    ${res}
    ${flag}    Result Analysis    ${res}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${username}    ${EMPTY}    ${pass1}    ${3}    ${0}
    #查询机构详细信息
    ${res}    GetPersonOrganizationAsyncPost    ${token}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${6014}    Organization Code Empty error
    Should Be True    ${flag}

Exception_002_查询机构详细信息，token非空检验
    [Setup]
    [Template]
    #查询机构详细信息
    ${res}    GetPersonOrganizationAsyncPost    ${EMPTY}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_003_查询机构详细信息，token正确性检验
    [Setup]
    [Template]
    #查询机构详细信息
    ${res}    GetPersonOrganizationAsyncPost    11111
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

*** Keywords ***
