*** Settings ***
Documentation     客户端获取Server配置
Suite Setup
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/GetServerSettingAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_客户端获取Server配置
    [Template]
    #获取Token
    ${token}    GetCommonLoginAsyncToken    ${user_jo0221}[0]    ${EMPTY}    ${user_jo0221}[1]    ${3}    ${0}
    Log    ${token}
    #获取机构配置信息
    ${res}    GetServerSettingAsyncPost    ${token}
    Log    ${res}
    ${content}    Get From Dictionary    ${res}    content
    #校验
    Should Not Be Empty    ${content}

Exception_001_客户端获取Server配置，Token非空校验
    [Template]
    #获取机构配置信息,Token传入空值
    ${res}    GetServerSettingAsyncPost    ${EMPTY}
    #校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_002_客户端获取Server配置，Token正确性校验
    [Template]
    #获取机构配置信息,Token传入不正确的值
    ${res}    GetServerSettingAsyncPost    111111
    #校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

*** Keywords ***
