*** Settings ***
Documentation     客户端-删除部门
Resource          ../../../CommonConfig/Config.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/AddOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/SearchOrganizationsAsync.robot
Resource          ../../../AllApi/ClientAPI/OrganizationInformationApi/RemoveOrganizationsAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_删除组织，删除单个组织
    #随机生成组织名
    ${oranName}    Random Characters
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    #添加组织
    ${res}    AddOrganizationsAsyncPost    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${EMPTY}    ${patientType}[0]    ${languageCode}[0]
    Log    ${res}
    #添加组织校验
    ${flag}    Result Analysis    ${res}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #搜索组织，返回OrganizationCode
    ${organizationCode}    SearchOrganizationsAsyncOrganizationCode    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    #删除组织
    ${response}    RemoveOrganizationsAsyncPost    ${token}    ${organizationCode}
    #删除组织校验
    ${flag}    Result Analysis    ${response}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    ${res1}    SearchOrganizationsAsyncPost    ${token}    ${oranName}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    ${content}    Get From Dictionary    ${res1}    content
    Should Be Empty    ${content}

Class_002_删除组织，删除多个组织
    #随机生成组织名
    ${oranName1}    Random Characters
    ${oranName2}    Random Characters
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    #添加组织1
    ${res1}    AddOrganizationsAsyncPost    ${token}    ${oranName1}    ${organizationInfo_mao}[0]    ${EMPTY}    ${patientType}[0]    ${languageCode}[0]
    Log    ${res1}
    #添加组织1校验
    ${flag}    Result Analysis    ${res1}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #搜索组织1，返回OrganizationCode
    ${organizationCode1}    SearchOrganizationsAsyncOrganizationCode    ${token}    ${oranName1}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    #添加组织2
    ${res2}    AddOrganizationsAsyncPost    ${token}    ${oranName2}    ${organizationInfo_mao}[0]    ${EMPTY}    ${patientType}[0]    ${languageCode}[0]
    Log    ${res2}
    #添加组织2校验
    ${flag}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #搜索组织2，返回OrganizationCode
    ${organizationCode2}    SearchOrganizationsAsyncOrganizationCode    ${token}    ${oranName2}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    #删除组织
    ${response}    RemoveOrganizationsAsyncPost    ${token}    ${organizationCode1},${organizationCode2}
    #删除组织校验
    ${flag}    Result Analysis    ${response}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    ${res3}    SearchOrganizationsAsyncPost    ${token}    ${oranName1}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    ${content}    Get From Dictionary    ${res3}    content
    Should Be Empty    ${content}
    ${res4}    SearchOrganizationsAsyncPost    ${token}    ${oranName2}    ${organizationInfo_mao}[0]    ${organizationType}[1]
    ${content}    Get From Dictionary    ${res4}    content
    Should Be Empty    ${content}

Exception_001_删除组织，Token非空校验
    #删除组织,Token传入空值
    ${res}    RemoveOrganizationsAsyncPost    ${EMPTY}    ${EMPTY}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_002_删除组织，Token正确性校验
    #删除组织,Token传入错误的值
    ${res}    RemoveOrganizationsAsyncPost    11111111111    ${EMPTY}
    #返回error信息校验
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

*** Keywords ***
