*** Settings ***
Documentation     创建病人
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Library           CustomLibrary

*** Variables ***

*** Test Cases ***
animalSuite
    [Tags]    inexecution
    ${body}    Create Dictionary
    Set To Dictionary    ${body}    jsonrpc    2.0
    Set To Dictionary    ${body}    method    CreatePatient
    ${params}    Create List
    ${param}    Create Dictionary
    Set To Dictionary    ${param}    Token    0126f5d7ef044088b075246c65a410ba
    ${PatientDatas}    Create List
    ${AnimalInfoName}    Create Dictionary    Key=AnimalInfoName    Value="11"
    ${AnimalInfoPhone}    Create Dictionary    Key=AnimalInfoPhone    Value="11"
    ${AnimalInfoIdentityCard}    Create Dictionary    Key=AnimalInfoIdentityCard    Value="11"
    ${Species}    Create Dictionary    Key=Species    Value="11"
    ${Breed}    Create Dictionary    Key=Breed    Value="11"
    ${AgeYear}    Create Dictionary    Key=AgeYear    Value="11"
    ${AgeMonth}    Create Dictionary    Key=AgeMonth    Value="11"
    ${AgeWeek}    Create Dictionary    Key=AgeWeek    Value="11"
    ${AgeDay}    Create Dictionary    Key=AgeDay    Value="11"
    ${AgeUnits}    Create Dictionary    Key=AgeUnits    Value="11"
    ${AnimalInfoSex}    Create Dictionary    Key=AnimalInfoSex    Value="11"
    ${AnimalInfoID}    Create Dictionary    Key=AnimalInfoID    Value="11"
    Append To List    ${PatientDatas}    ${AnimalInfoName}
    Append To List    ${PatientDatas}    ${AnimalInfoPhone}
    Append To List    ${PatientDatas}    ${AnimalInfoIdentityCard}
    Append To List    ${PatientDatas}    ${Species}
    Append To List    ${PatientDatas}    ${Breed}
    Append To List    ${PatientDatas}    ${AgeYear}
    Append To List    ${PatientDatas}    ${AgeMonth}
    Append To List    ${PatientDatas}    ${AgeWeek}
    Append To List    ${PatientDatas}    ${AgeDay}
    Append To List    ${PatientDatas}    ${AgeUnits}
    Append To List    ${PatientDatas}    ${AnimalInfoSex}
    Append To List    ${PatientDatas}    ${AnimalInfoID}
    Set To Dictionary    ${param}    PatientData    ${PatientDatas}
    ${AssignmentUserCodes}    Create List
    Append To List    ${AssignmentUserCodes}    uc_code01
    Append To List    ${AssignmentUserCodes}    uc_code02
    Set To Dictionary    ${param}    AssignmentUserCodes    ${AssignmentUserCodes}
    Append To List    ${params}    ${param}
    Set To Dictionary    ${body}    params    ${params}
    Set To Dictionary    ${body}    id    1
    Log    ${body}

Class_001_创建病人（人用）
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${res}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    Log    ${res}
    #校验
    ${patientCode}    Get From Dictionary    ${res}    content
    Should Not Be Empty    ${patientCode}

Class_002_创建病人（人用）,除身份证号
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    a0==au==c0==bK==b0==ae==au==be==    51    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    1971-12-10    Male    ${EMPTY}    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/4CE7FE8406AB4E9CBB7E84D0DD76002F.dat
    log    ${PatientDatas}
    ${res}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    Log    ${res}
    #校验
    ${patientCode}    Get From Dictionary    ${res}    content
    Should Not Be Empty    ${patientCode}

Exception_001_创建病人，Token值非空校验
    #创建病人，Token传入空值
    ${res}    CreatePatientAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_创建病人，Token值正确性校验
    #创建病人，Token传入错误的值
    ${res}    CreatePatientAsyncPost    1111222222    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_待修改创建病人，PatientData值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #创建病人，PatientData传入空值
    ${res}    CreatePatientAsyncPost    ${token}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4025}
    Should Be True    ${flag}

*** Keywords ***
