*** Settings ***
Library           CustomLibrary
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientByUnregisteredAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/DeviceAPI/DeviceIRemedicalService/CreateExamInfoAsync.robot
Resource          ../../../AllApi/DeviceAPI/DeviceIRemedicalService/UploadExamDataAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot

*** Test Cases ***
Class_001_未登记关联创建病人
    [Tags]    inexecution
    #超声设备连接云服务(JMHLHL)，获取超声设备Token
    ${usToken}    ConnectAsync.GetConnectAsyncToken    BFEBFBFF000906EA-S3YHNX0KC24771X    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #超声机传一条未登记的病人检查
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${patientDatas}    patient_body    ${enName}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    20230602111    ${EMPTY}
    ${patientScanInfos}    create_record    Routine    55    165    ${EMPTY}    ${EMPTY}
    ${res_CreateExam}    CreateExamInfoAsyncPost_ExamCode    ${usToken}    Person    ${EMPTY}    ${patientDatas}    ${patientScanInfos}
    #${res_uploadExamData}    UploadExamDataAsyncPost    ${usToken}    ${res_CreateExam}    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/4A18DA330CA24CA0935E09057498EC54.jpg    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/C5EE8AA2DD26437DBFF48B337712220E.vid    82604    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/64D98B9B8D314E60A58DD448E0F658F5.jpg    ABD    Abd General    0
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取未登记的病人编码
    ${startTime}=    Get Current Date    UTC    - 1 hours
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res_Patient}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    1
    #获取病人code
    ${pageData}    Get From Dictionary    ${res_Patient}[content]    PageData
    ${first_dit}    Set Variable    ${pageData[0]}
    ${patientCode}    Get From Dictionary    ${first_dit}    PatientCode
    #未登记关联创建病人
    ${res}    CreatePatientByUnregisteredAsyncPost    ${token}    ${patientCode}    ${enName}
    #未登记关联创建病人校验
    ${flag}    Result Analysis    ${res}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}

Exception_001_未登记关联创建病人，Token值非空校验
    #未登记关联创建病人,Token值传入空值
    ${res}    CreatePatientByUnregisteredAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_未登记关联创建病人，Token值正确性校验
    #未登记关联创建病人,传入错误的Token值
    ${res}    CreatePatientByUnregisteredAsyncPost    1234@#￥afff    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_未登记关联创建病人，UnregisteredPatientCode值正确性校验
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #未登记关联创建病人,传入错误的UnregisteredPatientCode值
    ${res}    CreatePatientByUnregisteredAsyncPost    ${token}    1234aaa    TFk/U+Yja0==bu==a0==au==
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4053}
    Should Be True    ${flag}

Exception_004_未登记关联创建病人，UnregisteredPatientCode值非空校验
    [Tags]    inexecution
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #未登记关联创建病人,UnregisteredPatientCode值传入空值
    ${res}    CreatePatientByUnregisteredAsyncPost    ${token}    ${EMPTY}    TFk/U+Yja0==bu==a0==au==
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4053}
    Should Be True    ${flag}

Exception_005_未登记关联创建病人，PatientName值非空校验
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #未登记关联创建病人,PatientName值传入空值
    ${res}    CreatePatientByUnregisteredAsyncPost    ${token}    47100F83C24D44C68150892449C23798    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4052}
    Should Be True    ${flag}
