*** Settings ***
Documentation     查询病人详细信息
Test Setup
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientByCodeAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_查询病人详细信息
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #创建病人
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    #${res}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #分页查询病人列表
    #${startTime}=    Get Current Date    UTC    - 1 days
    #${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    #${endTime}=    Get Current Date    UTC
    #${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    #${res1}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    2
    #获取病人code
    #${pageData}    Get From Dictionary    ${res1}[content]    PageData
    #${first_dit}     Set Variable    ${pageData[0]}
    #${patientCode}    Get From Dictionary    ${first_dit}    PatientCode
    #查询病人详细信息
    ${res2}    FindPatientByCodeAsyncPost    ${token}    ${patientCode}
    #查询病人详细信息校验
    ${patientCode_res}    Get From Dictionary    ${res2}[content]    PatientCode
    Should Be Equal As Strings    ${patientCode_res}    ${patientCode}

Exception_001_查询病人详细信息，Token值非空校验
    [Template]
    #查询病人详细信息，Token传入空值
    ${res}    FindPatientByCodeAsyncPost    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_查询病人详细信息，Token值正确性校验
    [Template]
    #查询病人详细信息，传入错误的Token值
    ${res}    FindPatientByCodeAsyncPost    1111112222222    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_查询病人详细信息，Code值非空校验
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #查询病人详细信息，Code传入空值
    ${res}    FindPatientByCodeAsyncPost    ${token}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4046}
    Should Be True    ${flag}

Exception_004_查询病人详细信息，传入不存在的Code值
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #查询病人详细信息，传入不存在的Code值
    ${res}    FindPatientByCodeAsyncPost    ${token}    111@#￥
    #校验
    Should Be Empty    ${res}[content]

*** Keywords ***
