*** Settings ***
Documentation     分页查询病人列表
Suite Setup
Test Setup
Library           DateTime
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot
Library           CustomLibrary

*** Variables ***

*** Test Cases ***
Class_001_分页查询病人列表
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #分页查询病人列表
    ${startTime}=    Get Current Date    UTC    - 30 days
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res}    FindPatientsAsyncPost    ${token}    1    100    ${EMPTY}    ${startTime}    ${endTime}    0
    #校验
    Should Not Be Empty    ${res}[content]

Class_002_分页查询病人列表，未登记病人
    [Tags]    inexecution
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #分页查询病人列表
    ${startTime}=    Get Current Date    UTC    - 30 days
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res}    FindPatientsAsyncPost    ${token}    1    100    ${EMPTY}    ${startTime}    ${endTime}    1
    #校验
    ${pageData}    Get From Dictionary    ${res}[content]    PageData
    Log    ${pageData}
    ${first_dict}=    Set Variable    ${pageData[0]}
    Log    ${first_dict}
    ${is_valid}=    Get From Dictionary    ${first_dict}    IsValid
    Log    ${is_valid}
    Should Not Be True    ${is_valid}

Class_003_分页查询病人列表，已登记病人
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #分页查询病人列表
    ${startTime}=    Get Current Date    UTC    - 30 days
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res}    FindPatientsAsyncPost    ${token}    1    100    ${EMPTY}    ${startTime}    ${endTime}    2
    #校验
    ${pageData}    Get From Dictionary    ${res}[content]    PageData
    Log    ${pageData}
    ${first_dict}=    Set Variable    ${pageData[0]}
    Log    ${first_dict}
    ${is_valid}=    Get From Dictionary    ${first_dict}    IsValid
    Log    ${is_valid}
    Should Be True    ${is_valid}

Class_004_分页查询病人列表，KeyWord存在
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #创建病人
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${res}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    #分页查询病人列表
    ${startTime}=    Get Current Date    UTC    - 30 days
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res1}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    0
    #校验
    ${pageData}    Get From Dictionary    ${res1}[content]    PageData
    Log    ${pageData}
    ${first_dict}=    Set Variable    ${pageData[0]}
    Log    ${first_dict}
    ${patientData}    Get From Dictionary    ${first_dict}    PatientData
    Should Contain    ${patientData}[0][Value]    ${name}

Class_005_分页查询病人列表，KeyWord不存在
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #分页查询病人列表
    ${startTime}=    Get Current Date    UTC    - 30 days
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res1}    FindPatientsAsyncPost    ${token}    1    100    12!@$#%^^&&ADFVCsdtgd    ${startTime}    ${endTime}    0
    #校验
    ${pageData}    Get From Dictionary    ${res1}[content]    PageData
    Should Be Empty    ${pageData}

Exception_001_分页查询病人列表，Token值非空校验
    #分页查询病人列表，Token值传入空值
    ${res}    FindPatientsAsyncPost    ${EMPTY}    1    100    ${EMPTY}    ${EMPTY}    ${EMPTY}    0
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_分页查询病人列表，Token值正确性校验
    #分页查询病人列表，Token值传入空值
    ${res}    FindPatientsAsyncPost    ！@#￥1243wer    1    100    ${EMPTY}    ${EMPTY}    ${EMPTY}    0
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_分页查询病人列表，IsValid值正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${startTime}=    Get Current Date    UTC    - 30 days
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    #分页查询病人列表，Token值传入空值
    ${res}    FindPatientsAsyncPost    ${token}    1    100    ${EMPTY}    ${startTime}    ${startTime}    999
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4042}
    Should Be True    ${flag}

*** Keywords ***
