*** Settings ***
Documentation     获取有效相同病人名称的列表
Suite Setup
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindValidPatientsByNameAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientByUnregisteredAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_获取有效相同病人名称的列表
    [Template]
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${res}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    Log    ${res}
    #获取有效相同病人名称的列表
    ${res1}    FindValidPatientsByNameAsyncPost    ${token}    ${enName}
    Log    ${res1}
    #校验，校验key为Name对应的value值和${enName}一致
    Should Not Be Empty    ${res1}[content]
    #${content}    Set Variable    ${res1}[content]
    #Log    ${content}
    #${content_1}    Set Variable    ${content}[0]
    #Log    ${content_1}
    ${PatientData}    Set Variable    ${res1}[content][0][PatientData]
    Should Not Be Empty    ${PatientData}
    #${PatientData_1}    Set Variable    ${PatientData}[0]
    #Log    ${PatientData_1}
    Should Be Equal As Strings    ${PatientData}[0][Value]    ${name}

Exception_001_获取有效相同病人名称的列表，Token值非空校验
    #获取有效相同病人名称的列表，Token值非空校验
    ${res}    FindValidPatientsByNameAsyncPost    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_获取有效相同病人名称的列表，Token值正确性校验
    #获取有效相同病人名称的列表，传入不正确的Token值
    ${res}    FindValidPatientsByNameAsyncPost    11112222    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_获取有效相同病人名称的列表，Name值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取有效相同病人名称的列表，Name传入空值
    ${res}    FindValidPatientsByNameAsyncPost    ${token}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${6001}
    Should Be True    ${flag}

Exception_004_获取有效相同病人名称的列表，传入不存在的Name值
    [Tags]    inexecution
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取有效相同病人名称的列表，传入不存在的Name值
    ${res}    FindValidPatientsByNameAsyncPost    ${token}    ！@#￥%%…
    #校验
    Should Be Empty    ${res}[content]

*** Keywords ***
