*** Settings ***
Documentation     删除病人
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Library           CustomLibrary
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/RemovePatientsAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_删除病人
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #${res_CreatePatient}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    #Log    ${res_CreatePatient}
    #分页查询病人列表
    #${startTime}=    Get Current Date    UTC    - 1 hours
    #${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    #${endTime}=    Get Current Date    UTC
    #${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    #${res_findPatient}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    2
    #获取病人code
    #${pageData}    Get From Dictionary    ${res_findPatient}[content]    PageData
    #${first_dit}    Set Variable    ${pageData[0]}
    #${patientCode}    Get From Dictionary    ${first_dit}    PatientCode
    #删除病人
    ${res_removePatient}    RemovePatientsAsyncPost    ${token}    ${patientCode}
    #校验
    ${flag_removePatient}    Result Analysis    ${res_removePatient}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag_removePatient}

Class_002_删除多个病人
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${name1}    Random Characters8
    ${enName1}    Encode Base64    ${name1}
    #创建病人
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #${res_CreatePatient}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    ${PatientDatas1}    patient_body    ${enName1}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    ${patientCode1}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas1}    ${EMPTY}
    #${res_CreatePatient1}    CreatePatientAsyncPost    ${token}    ${PatientDatas1}    ${EMPTY}
    #分页查询病人列表
    #${startTime}=    Get Current Date    UTC    - 1 hours
    #${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    #${endTime}=    Get Current Date    UTC
    #${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    #${res_findPatient}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    2
    #${res_findPatient1}    FindPatientsAsyncPost    ${token}    1    100    ${name1}    ${startTime}    ${endTime}    2
    #获取病人code
    #${pageData}    Get From Dictionary    ${res_findPatient}[content]    PageData
    #${first_dit}    Set Variable    ${pageData[0]}
    #${patientCode}    Get From Dictionary    ${first_dit}    PatientCode
    #${pageData1}    Get From Dictionary    ${res_findPatient1}[content]    PageData
    #${first_dit1}    Set Variable    ${pageData1[0]}
    #${patientCode1}    Get From Dictionary    ${first_dit1}    PatientCode
    #删除病人
    ${res_removePatient}    RemovePatientsAsyncPost    ${token}    ${patientCode},${patientCode1}
    #校验
    ${flag_removePatient}    Result Analysis    ${res_removePatient}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag_removePatient}

Exception_001_删除病人，Token值非空校验
    #Token值传入空值
    ${res}    RemovePatientsAsyncPost    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_删除病人，Token值正确性校验
    #传入错误的Token值
    ${res}    RemovePatientsAsyncPost    123aaaa!@#    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_删除病人，PatientCodes值非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #传入错误的Token值
    ${res}    RemovePatientsAsyncPost    ${token}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${EMPTY}
    Should Be True    ${flag}

*** Keywords ***
