*** Settings ***
Documentation     设置成有效已登记病人接口
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindValidPatientsByNameAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Resource          ../../../AllApi/DeviceAPI/DevicceInfoApi/ConnectAsync.robot
Resource          ../../../AllApi/DeviceAPI/DeviceIRemedicalService/CreateExamInfoAsync.robot
Resource          ../../../AllApi/DeviceAPI/DeviceIRemedicalService/UploadExamDataAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/SetValidPatientAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientByUnregisteredAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_设置成有效已登记病人接口
    [Tags]    inexecution
    #超声设备连接云服务(JMHLHL)，获取超声设备Token
    ${usToken}    ConnectAsync.GetConnectAsyncToken    BFEBFBFF000906EA-S3YHNX0KC24771X    ${EMPTY}    USDemoV2    US    2.11.0    2.2.27.5    I5-8400    zh-CN    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    0    0    ${EMPTY}
    #超声机传一条未登记的病人检查
    ${name}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${patientDatas}    patient_body    ${enName}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    20230602111    ${EMPTY}
    ${patientScanInfos}    create_record    Routine    55    165    ${EMPTY}    ${EMPTY}
    ${res_CreateExam}    CreateExamInfoAsyncPost_ExamCode    ${usToken}    Person    ${EMPTY}    ${patientDatas}    ${patientScanInfos}
    ${res_uploadExamData}    UploadExamDataAsyncPost    ${usToken}    ${res_CreateExam}    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/4A18DA330CA24CA0935E09057498EC54.jpg    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/C5EE8AA2DD26437DBFF48B337712220E.vid    82604    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/64D98B9B8D314E60A58DD448E0F658F5.jpg    ABD    Abd General    0
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #获取未登记的病人编码
    ${startTime}=    Get Current Date    UTC    - 1 hours
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res_Patient}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    1
    #获取未登记病人code
    ${pageData}    Get From Dictionary    ${res_Patient}[content]    PageData
    ${first_dit}    Set Variable    ${pageData[0]}
    ${patientCodeOld}    Get From Dictionary    ${first_dit}    PatientCode
    #未登记关联创建病人
    ${res}    CreatePatientByUnregisteredAsyncPost    ${token}    ${patientCodeOld}    ${enName}
    #未登记关联创建病人校验
    ${flag}    Result Analysis    ${res}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    #获取未登记关联创建病人code
    ${res1}    FindValidPatientsByNameAsyncPost    ${token}    ${enName}
    Log    ${res1}
    ${PatientCodeNew}    Get From Dictionary    ${res1}[content][0]    PatientCode
    #设置成有效已登记病人
    ${res_SetValidPatient}    SetValidPatientAsyncPost    ${token}    ${PatientCodeNew}    ${patientCodeOld}    true
    #设置成有效已登记病人校验
    ${flag_SetValidPatient}    Result Analysis    ${res_SetValidPatient}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag_SetValidPatient}

Exception_001_设置成有效已登记病人接口，Token值非空校验
    #Token值传入空值
    ${res}    SetValidPatientAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_设置成有效已登记病人接口，Token值正确性校验
    #传入错误的Token值
    ${res}    SetValidPatientAsyncPost    123awes!@#$$    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003_设置成有效已登记病人接口，NewPatientCode非空校验
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #NewPatientCode值传入空值
    ${res}    SetValidPatientAsyncPost    ${token}    ${EMPTY}    56AE4293F9D64B92A125C3173FA69E19    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4046}
    Should Be True    ${flag}

Exception_004_设置成有效已登记病人接口，NewPatientCode正确性校验
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #NewPatientCode值传入空值
    ${res}    SetValidPatientAsyncPost    ${token}    aaa123!@#    56AE4293F9D64B92A125C3173FA69E19    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4014}
    Should Be True    ${flag}

Exception_005_设置成有效已登记病人接口，OldPatientCode非空校验
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #NewPatientCode值传入空值
    ${res}    SetValidPatientAsyncPost    ${token}    56AE4293F9D64B92A125C3173FA69E19    ${EMPTY}    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4046}
    Should Be True    ${flag}

Exception_006_设置成有效已登记病人接口，OldPatientCode正确性校验
    #杏聆荟客户端登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #NewPatientCode值传入空值
    ${res}    SetValidPatientAsyncPost    ${token}    ${EMPTY}    123qaz!@#    false
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4046}
    Should Be True    ${flag}

*** Keywords ***
