*** Settings ***
Documentation     修改病人信息
Library           CustomLibrary
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/CreatePatientAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/UpdatePatientAsync.robot
Resource          ../../../AllApi/ClientAPI/PatientInformationApi/FindPatientsAsync.robot

*** Variables ***

*** Test Cases ***
Class_001_修改病人信息（人用）
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #创建病人
    ${name}    Random Characters8
    ${name1}    Random Characters8
    ${enName}    Encode Base64    ${name}
    ${enName1}    Encode Base64    ${name1}
    ${PatientDatas}    patient_body    ${enName}    ae==c0==c0==bu==au==ae==a0==c0==be==bK==aK==    ${EMPTY}    a0==au==c0==bK==b0==ae==au==be==    51    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    1971-12-10    Male    ${EMPTY}    https://flyinsono-bj-1300984704.cos.ap-beijing.myqcloud.com/4CE7FE8406AB4E9CBB7E84D0DD76002F.dat
    log    ${PatientDatas}
    ${patientCode}    CreatePatientAsyncPost_PatientCode    ${token}    ${PatientDatas}    ${EMPTY}
    #${res}    CreatePatientAsyncPost    ${token}    ${PatientDatas}    ${EMPTY}
    #分页查询病人列表
    #${startTime}=    Get Current Date    UTC    - 1 days
    #${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    #${endTime}=    Get Current Date    UTC
    #${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    #${res1}    FindPatientsAsyncPost    ${token}    1    100    ${name}    ${startTime}    ${endTime}    2
    #获取病人code
    #${pageData}    Get From Dictionary    ${res1}[content]    PageData
    #${first_dit}    Set Variable    ${pageData[0]}
    #${patientCode}    Get From Dictionary    ${first_dit}    PatientCode
    #修改病人信息
    ${updPatientDatas}    patient_body    ${enName1}    ae==ae==ae==ae==ae==ae==ae==ae==ae==ae==ae==    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}    Year    ${EMPTY}    Female    ${EMPTY}    ${EMPTY}
    ${res2}    UpdatePatientAsyncPost    ${token}    ${patientCode}    ${updPatientDatas}    ${EMPTY}
    ${flag1}    Result Analysis    ${res2}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag1}

Exception_001_修改病人信息，Token值非空校验
    #修改病人信息，Token值传入空值
    ${res}    UpdatePatientAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_002_修改病人信息，Token值正确性校验
    #修改病人信息，传入错误的Token值
    ${res}    UpdatePatientAsyncPost    ！@#￥%……&qee333    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${1}
    Should Be True    ${flag}

Exception_003修改病人信息，Code非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #修改病人信息，Code值传入空值
    ${newlist}    Create List
    ${patientData}    Create Dictionary
    Append To List    ${newlist}    ${patientData}
    ${res}    UpdatePatientAsyncPost    ${token}    ${EMPTY}    ${newlist}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${9}
    Should Be True    ${flag}

Exception_004修改病人信息，Cod正确性校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #修改病人信息，Code值传入空值
    ${newlist}    Create List
    ${patientData}    Create Dictionary
    Append To List    ${newlist}    ${patientData}
    ${res}    UpdatePatientAsyncPost    ${token}    123!@#qaz    ${newlist}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4014}
    Should Be True    ${flag}

Exception_005_修改病人信息，PatientData非空校验
    #登录，获取用户Token
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    #分页查询病人列表
    ${startTime}=    Get Current Date    UTC    - 30 days
    ${startTime}=    Convert Date    ${startTime}    %Y-%m-%dT%H:%M:%SZ
    ${endTime}=    Get Current Date    UTC
    ${endTime}=    Convert Date    ${endTime}    %Y-%m-%dT%H:%M:%SZ
    ${res}    FindPatientsAsyncPost    ${token}    1    100    ${EMPTY}    ${startTime}    ${endTime}    0
    #获取病人code
    ${pageData}    Get From Dictionary    ${res}[content]    PageData
    ${first_dit}    Set Variable    ${pageData[0]}
    ${patientCode}    Get From Dictionary    ${first_dit}    PatientCode
    #修改病人信息，Code值传入空值
    ${res}    UpdatePatientAsyncPost    ${token}    ${patientCode}    ${EMPTY}    ${EMPTY}
    #校验
    ${flag}    Result Analysis Code    ${res}    false    ${4025}
    Should Be True    ${flag}
