*** Settings ***
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/SendSMSVerificationCodeAsync.robot
Library           Collections

*** Variables ***

*** Test Cases ***
Class_001_用户名登录
    [Template]
    ${result}    CommonLoginAsyncPost    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    ${content}    Get From Dictionary    ${result}    content
    ${loginState}    Get From Dictionary    ${content}    LoginState
    Should Be Equal As Numbers    ${loginState}    0

Class_002_手机号登录（密码）
    [Template]
    ${result}    CommonLoginAsyncPost    ${user_phone}[0]    ${EMPTY}    ${user_phone}[1]    ${3}    ${0}
    ${content}    Get From Dictionary    ${result}    content
    ${loginState}    Get From Dictionary    ${content}    LoginState
    ${flag}    Result Analysis    ${result}    true    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    Should Be Equal As Numbers    ${loginState}    0

Class_003_邮箱登录（密码）
    [Template]
    ${result}    CommonLoginAsyncPost    ${user_email}[0]    ${EMPTY}    ${user_email}[1]    ${3}    ${0}
    ${content}    Get From Dictionary    ${result}    content
    ${loginState}    Get From Dictionary    ${content}    LoginState
    ${flag}    Result Analysis    ${result}    true    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    Should Be Equal As Numbers    ${loginState}    0

Exception_001_AnyAccount字段非空校验
    ${res}    CommonLoginAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6049}    Account is empty
    Should Be True    ${flag}

Exception_002_用户名登录，密码正确性校验
    ${result}    CommonLoginAsyncPost    mao    ${EMPTY}    123eee    ${3}    ${0}
    ${content}    Get From Dictionary    ${result}    content
    ${loginState}    Get From Dictionary    ${content}    LoginState
    ${flag}    Result Analysis    ${result}    true    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    Should Be Equal As Numbers    ${loginState}    1

Exception_003_手机号登录，密码正确性校验
    ${result}    CommonLoginAsyncPost    18862108573    ${EMPTY}    123eee    ${3}    ${0}
    ${content}    Get From Dictionary    ${result}    content
    ${loginState}    Get From Dictionary    ${content}    LoginState
    ${flag}    Result Analysis    ${result}    true    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    Should Be Equal As Numbers    ${loginState}    1

Exception_004_邮箱登录，密码正确性校验
    ${result}    CommonLoginAsyncPost    jo.xue@vinno.com    ${EMPTY}    123eee    ${3}    ${0}
    ${content}    Get From Dictionary    ${result}    content
    ${loginState}    Get From Dictionary    ${content}    LoginState
    ${flag}    Result Analysis    ${result}    true    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}
    Should Be Equal As Numbers    ${loginState}    1

Exception_005_手机号登录，验证码正确性校验
    ${result}    SendSMSVerificationCodeAsyncPost    18862108573
    ${res}    CommonLoginAsyncPost    18862108573    11111    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6034}    VerificationCode is illegality
    Should Be True    ${flag}

Exception_006_邮箱登录，验证码正确性校验
    ${res}    CommonLoginAsyncPost    jo.xue@vinno.com    124785    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6034}    VerificationCode is illegality
    Should Be True    ${flag}

Exception_007_用户名登录，密码非空校验
    ${res}    CommonLoginAsyncPost    xuejiao    ${EMPTY}    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6042}    Incorrect password format
    Should Be True    ${flag}

Exception_008_手机号登录，验证码非空校验
    ${res}    CommonLoginAsyncPost    18862108573    ${EMPTY}    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6042}    Incorrect password format
    Should Be True    ${flag}

Exception_009_手机号登录，密码非空校验
    ${res}    CommonLoginAsyncPost    18862108573    ${EMPTY}    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6042}    Incorrect password format
    Should Be True    ${flag}

Exception_010_邮箱登录，验证码非空校验
    ${res}    CommonLoginAsyncPost    jo.xue@vinno.com    ${EMPTY}    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6042}    Incorrect password format
    Should Be True    ${flag}

Exception_011_邮箱登录，密码非空校验
    ${res}    CommonLoginAsyncPost    jo.xue@vinno.com    ${EMPTY}    ${EMPTY}    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6042}    Incorrect password format
    Should Be True    ${flag}

Exception_012_未注册的用户名登录
    ${res}    CommonLoginAsyncPost    JOHAHAHA4444444    ${EMPTY}    avc123    ${0}    ${0}
    ${flag}    Result Analysis    ${res}    false    ${6037}    User not registered
    Should Be True    ${flag}

*** Keywords ***
