*** Settings ***
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonSignUpAsync.robot
Library           CustomLibrary

*** Variables ***

*** Test Cases ***
Class_001_用户名注册
    [Template]
    ${username}    Random Characters
    ${res}    CommonSignUpAsyncPost    ${username}    ${EMPTY}    ${pass1}
    Log    ${res}
    ${flag}    Result Analysis    ${res}    True    ${EMPTY}    ${EMPTY}
    Should Be True    ${flag}

Exception_001_注册用户名重复校验
    ${res}    CommonSignUpAsyncPost    test    ${EMPTY}    ${pass1}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6044}
    #Should Be Equal As Strings    ${message}    UserName is registered
    ${flag}    result_analysis    ${res}    false    ${6044}    UserName is registered
    Should Be True    ${flag}

Exception_002_注册手机号重复校验
    ${res}    CommonSignUpAsyncPost    18862108573    ${EMPTY}    ${pass1}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6045}
    #Should Be Equal As Strings    ${message}    Phone is registered
    ${flag}    result_analysis    ${res}    false    ${6045}    Phone is registered
    Should Be True    ${flag}

Exception_003_注册邮箱重复校验
    ${res}    CommonSignUpAsyncPost    jo.xue@vinno.com    ${EMPTY}    ${pass1}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6046}
    #Should Be Equal As Strings    ${message}    Email is registered
    ${flag}    result_analysis    ${res}    false    ${6046}    Email is registered
    Should Be True    ${flag}

Exception_004_用户名/手机号/邮箱非空校验
    ${res}    CommonSignUpAsyncPost    ${EMPTY}    ${EMPTY}    ${EMPTY}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6049}
    #Should Be Equal As Strings    ${message}    Account is empty
    ${flag}    result_analysis    ${res}    false    ${6049}    Account is empty
    Should Be True    ${flag}

Exception_005_用户名注册，密码非空校验
    ${res}    CommonSignUpAsyncPost    xuejojojo    ${EMPTY}    ${EMPTY}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6038}
    #Should Be Equal As Strings    ${message}    Incorrect password format
    ${flag}    result_analysis    ${res}    false    ${6038}    Incorrect password format
    Should Be True    ${flag}

Exception_006_手机号注册，验证码非空校验
    ${res}    CommonSignUpAsyncPost    18013114545    ${EMPTY}    ${EMPTY}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6034}
    #Should Be Equal As Strings    ${message}    VerificationCode is illegality
    ${flag}    result_analysis    ${res}    false    ${6034}    VerificationCode is illegality
    Should Be True    ${flag}

Exception_007_邮箱注册，验证码非空校验
    ${res}    CommonSignUpAsyncPost    18862108573@163.com    ${EMPTY}    ${EMPTY}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6034}
    #Should Be Equal As Strings    ${message}    VerificationCode is illegality
    ${flag}    result_analysis    ${res}    false    ${6034}    VerificationCode is illegality
    Should Be True    ${flag}

Exception_008_手机号注册，验证码正确性校验
    ${res}    CommonSignUpAsyncPost    18013114545    123456    ${EMPTY}
    #${code}    Get From Dictionary    ${res}    code
    #${message}    Get From Dictionary    ${res}    message
    #Should Be Equal As Numbers    ${code}    ${6034}
    #Should Be Equal As Strings    ${message}    VerificationCode is illegality
    ${flag}    result_analysis    ${res}    false    ${6034}    VerificationCode is illegality
    Should Be True    ${flag}

Exception_009_邮箱注册，验证码正确性校验
    ${res}    CommonSignUpAsyncPost    18862108573@163.com    9999    ${EMPTY}
    ${flag}    result_analysis    ${res}    false    ${6034}    VerificationCode is illegality
    Should Be True    ${flag}

Exception_010_密码规则校验
    [Documentation]    接口代码暂未做校验
    [Tags]    inexecution
    #密码规则校验，长度少于6位
    ${res}    CommonSignUpAsyncPost    1886210    ${EMPTY}    123
    ${code}    Get From Dictionary    ${res}    code
    ${message}    Get From Dictionary    ${res}    message
    Should Be Equal As Numbers    ${code}    ${10014}
    Should Be Equal As Strings    ${message}    Incorrect password format
    #密码规则校验，长度大于12位
    ${res}    CommonSignUpAsyncPost    22jo    ${EMPTY}    123456789abcd
    ${code}    Get From Dictionary    ${res}    code
    ${message}    Get From Dictionary    ${res}    message
    Should Be Equal As Numbers    ${code}    ${10014}
    Should Be Equal As Strings    ${message}    Incorrect password format
    #密码规则校验，密码仅包含数字
    ${res}    CommonSignUpAsyncPost    11jo    ${EMPTY}    1111111
    ${code}    Get From Dictionary    ${res}    code
    ${message}    Get From Dictionary    ${res}    message
    Should Be Equal As Numbers    ${code}    ${10014}
    Should Be Equal As Strings    ${message}    Incorrect password format
    #密码规则校验，密码仅包含字母
    ${res}    CommonSignUpAsyncPost    11jo    ${EMPTY}    abcdefg
    ${code}    Get From Dictionary    ${res}    code
    ${message}    Get From Dictionary    ${res}    message
    Should Be Equal As Numbers    ${code}    ${10014}
    Should Be Equal As Strings    ${message}    Incorrect password format
    #密码规则校验，密码包含非字母和数字
    ${res}    CommonSignUpAsyncPost    11jo    ${EMPTY}    123@abc
    ${code}    Get From Dictionary    ${res}    code
    ${message}    Get From Dictionary    ${res}    message
    Should Be Equal As Numbers    ${code}    ${10014}
    Should Be Equal As Strings    ${message}    Incorrect password format

*** Keywords ***
