*** Settings ***
Documentation     客户端-获取所有可认证角色
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/FindAuthenticationRolesAsync.robot
Resource          ../../../CommonConfig/Config.robot
Library           CustomLibrary

*** Variables ***

*** Test Cases ***
Class_001_获取所有可认证角色，中文
    [Setup]
    [Template]
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${res}    FindAuthenticationRolesAsyncPost    ${token}    zh-CN
    Log    ${res}
    ${flag}    Authentication Roles Check    ${res}[content]    zh-CN
    Should Be True    ${flag}

Class_002_获取所有可认证角色，英文
    [Setup]
    [Template]
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${res}    FindAuthenticationRolesAsyncPost    ${token}    en-US
    Log    ${res}
    Log    ${res}
    ${flag}    Authentication Roles Check    ${res}[content]    en-US
    Should Be True    ${flag}

Class_003_获取所有可认证角色，语言地区码传入空值
    [Setup]
    [Template]
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${res}    FindAuthenticationRolesAsyncPost    ${token}    ${EMPTY}
    Log    ${res}
    ${flag}    Authentication Roles Check    ${res}[content]    ${EMPTY}
    Should Be True    ${flag}

Class_004_获取所有可认证角色，语言地区码传入非特定值
    [Setup]
    [Template]
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${res}    FindAuthenticationRolesAsyncPost    ${token}    aabb
    Log    ${res}
    ${flag}    Authentication Roles Check    ${res}[content]    aabb
    Should Be True    ${flag}

Exception_001_获取所有可认证角色，Token非空校验
    [Setup]
    [Template]
    ${res}    FindAuthenticationRolesAsyncPost    ${EMPTY}    zh-CN
    Log    ${res}
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_002_获取所有可认证角色，Token正确性校验
    [Setup]
    [Template]
    ${res}    FindAuthenticationRolesAsyncPost    11111111    zh-CN
    Log    ${res}
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

*** Keywords ***
