*** Settings ***
Documentation     根据用户编码获取详情
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/CommonLoginAsync.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/GetUserByCodeAsync.robot
Resource          ../../../AllApi/ClientAPI/PersonalInformationApi/GetUserInfoAsync.robot
Resource          ../../../CommonConfig/Config.robot

*** Test Cases ***
Class_001_根据用户编码获取详情
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${userCode1}    GetUserInfoAsyncPostUserCode    ${token}
    ${res}    GetUserByCodeAsyncPost    ${token}    ${userCode1}
    ${content}    Get From Dictionary    ${res}    content
    ${userCode2}    Get From Dictionary    ${content}    UserCode
    Should Be Equal As Strings    ${userCode2}    ${userCode1}

Exception_001_根据用户编码获取详情，Token非空校验
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${userCode1}    GetUserInfoAsyncPostUserCode    ${token}
    ${res}    GetUserByCodeAsyncPost    ${EMPTY}    ${userCode1}
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_002_根据用户编码获取详情，Token正确性校验
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${userCode1}    GetUserInfoAsyncPostUserCode    ${token}
    ${res}    GetUserByCodeAsyncPost    aaaa11111    ${userCode1}
    ${flag}    Result Analysis    ${res}    false    ${1}    Permission validation error
    Should Be True    ${flag}

Exception_003_根据用户编码获取详情，用户编码非空校验
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${res}    GetUserByCodeAsyncPost    ${token}    ${EMPTY}
    ${flag}    Result Analysis    ${res}    false    ${9}    Code can't be null
    Should Be True    ${flag}

Exception_004_根据用户编码获取详情，用户编码正确性校验
    ${token}    GetCommonLoginAsyncToken    ${user_mao}[0]    ${EMPTY}    ${user_mao}[1]    ${3}    ${0}
    Log    ${token}
    ${res}    GetUserByCodeAsyncPost    ${token}    111AAA
    ${flag}    Result Analysis    ${res}    false    ${6027}    User not found
    Should Be True    ${flag}
